#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
#------------------------------------------------------------------------------------------------
#    Name:	Offset Some
#      By:	sdmitch
#   Usage:	Plugins>SDM Tools>Edge Tool>Offset Some
#		 Note:	
#			
#    Date:	May 2016
#------------------------------------------------------------------------------------------------
require 'Sketchup'
# ------------------  MENU SETUP ---------------------- #
unless $sdm_tools_menu
	$sdm_tools_menu = UI.menu("Plugins").add_submenu("SDM Tools")
	$sdm_Edge_tools = $sdm_tools_menu.add_submenu("Edge Tool")
	$sdm_Face_tools = $sdm_tools_menu.add_submenu("Face Tool")
	$sdm_CorG_tools = $sdm_tools_menu.add_submenu("CorG Tool")
	$sdm_Misc_tools = $sdm_tools_menu.add_submenu("Misc Tool")
end
unless file_loaded?(__FILE__)
	$sdm_Edge_tools.add_item("Offset Some") { SDM::Offset_Some.main }
	file_loaded(__FILE__)
end
# ------------------------------------------------------ #
module SDM

	module Offset_Some

		def self.main

			mod = Sketchup.active_model
			ent = mod.active_entities
			sel = mod.selection
			unless sel.empty? || sel.grep(Sketchup::Edge).length<2
				@JX ||= 300.mm
				val = UI.inputbox(["Taper By:"],[@JX],"Inset Edges")
				if val
					edges = sel.grep(Sketchup::Edge); @JX = val[0]
					face = edges[0].faces.find{|f| f.normal.perpendicular?(edges[0].line[1])}
					edges,f_pts,f_vts = self.sort_edges(sel,3)
					#f_pts.each{|p|ent.add_cpoint(p)}
					o_pts=[];o_pts<<f_pts[0];o_vcs=[];o_vcs<<X_AXIS
					vec1=nil;vec2=nil;last=f_pts.length-2;
					1.upto(last) do |a|
						vec1 = (f_pts[a+1]-f_pts[a]).normalize
						vec2 = (f_pts[a-1]-f_pts[a]).normalize
						if vec1.parallel? vec2
							vec3 = Geom::Vector3d.new(vec1.y,-vec1.x,0)
							ang = 90.degrees
						else
							vec3 = (vec1+vec2).normalize
							ang = vec1.angle_between(vec2)/2;
						end
						vec3.length = @JX/Math::sin(ang);
						t = Geom::Transformation.new(vec3)
						if (face.classify_point(f_pts[a].transform(t))==16)
							t = Geom::Transformation.new(vec3.reverse);
						end
						o_pts << f_pts[a].transform(t);
						if a==1
							hit = mod.raytest([o_pts[1],vec2])
							if hit
								#ent.add_cpoint(hit[0]);
								o_pts[0]=hit[0];o_vcs[0]=f_pts[0].vector_to(o_pts[0])
							end
						end
						o_vcs << vec3
						# ent.add_cline(f_pts[a],o_vcs[a])
					end
					hit = mod.raytest([o_pts[-1],vec1])
					if hit
						# ent.add_line(o_pts[-1],hit[0])
						o_pts << hit[0];
						o_vcs << f_pts[-1].vector_to(o_pts[-1])
					end
					begin
						ent.transform_by_vectors(f_vts,o_vcs)
					rescue
						puts f_vts.length,o_vcs.length
					end
				end
			else
				UI.messagebox "Select 2 or more Edges to be Moved"
			end
		end

		def self.sort_edges(sel,flag)
			old_order=sel.grep(Sketchup::Edge);new_order=[]
			return nil if old_order.empty?
			next_edge=old_order.select{|e| (e.start.edges&old_order).length==1}[0]
			next_edge=old_order.select{|e| (e.end.edges&old_order).length==1}[0] unless next_edge
			next_edge=old_order[0] unless next_edge#handle closed loops
			new_order<<next_edge; vert=next_edge.start; 
			vert=next_edge.end if (next_edge.end.edges&old_order).length==1
			pts=[]; old_order.delete(next_edge); vts=[]
			pts<<vert.position; vts<<vert
			until old_order.empty?
				vert=next_edge.other_vertex(vert)
				pts<<vert.position; vts<<vert
				edges=vert.edges&old_order;
				edges.delete(next_edge)
				next_edge=edges[0];
				new_order<<next_edge;
				old_order.delete(next_edge);
			end
			vert=next_edge.other_vertex(vert)
			pts<<vert.position; vts<<vert
			return new_order if flag==0
			return new_order,pts if flag==1
			return new_order,vts if flag==2
			return new_order,pts,vts if flag==3
		end
		
	end
	
end
